<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_commission;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_commission\MasterWorkerCommissionConfig;
use app\common\lists\ListsSearchInterface;
use app\common\model\master_worker\MasterWorker;


/**
 * MasterWorkerCommissionConfig列表
 * Class MasterWorkerCommissionConfigLists
 * @package app\adminapi\lists
 */
class MasterWorkerCommissionConfigLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/12/06 10:42
     */
    public function setSearch(): array
    {
        return [
            '=' => ['master_worker_id', 'submit_admin_id', 'examine_admin_id', 'voucher_status', 'notice_rule'],

        ];
    }

    public function queryWhere(){
        $where = [];
        if (isset($this->params['mobile_account']) && !empty($this->params['mobile_account'])) {
            $mw_ids = MasterWorker::where('mobile|account','like', '%' . $this->params['mobile_account'] . '%')->column('id');
            $where[] = [ 'master_worker_id','in',$mw_ids?:[0]];
        }
        return $where;
    }
    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/12/06 10:42
     */
    public function lists(): array
    {
        return MasterWorkerCommissionConfig::with(['masterWorker','examineAdmin'])->where($this->searchWhere)->where($this->queryWhere())
            ->field(['id', 'master_worker_id', 'submit_admin_id', 'examine_admin_id', 'voucher_status', 'notice_rule','block_data'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/12/06 10:42
     */
    public function count(): int
    {
        return MasterWorkerCommissionConfig::where($this->searchWhere)->count();
    }

}